// asyncProducer.h : Declaration of the CasyncProducer

#ifndef __ASYNCPRODUCER_H_
#define __ASYNCPRODUCER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CasyncProducer
class ATL_NO_VTABLE CasyncProducer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CasyncProducer, &CLSID_asyncProducer>,
	public ISupportErrorInfo,
	public IDispatchImpl<IasyncProducer, &IID_IasyncProducer, &LIBID_ASYNCSERVERLib>
{
public:
	CasyncProducer()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ASYNCPRODUCER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CasyncProducer)
	COM_INTERFACE_ENTRY(IasyncProducer)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IasyncProducer
public:
	STDMETHOD(GetAsyncData)(/*[out,retval]*/ BSTR* bstrData);
};

#endif //__ASYNCPRODUCER_H_
